// The query, text and entryfields  are defined in the 
// custom form for simplify.


class mDefault of FORM custom
   with (this)
      onGotFocus = class::ONGOTFOCUS
      onLostFocus = class::ONLOSTFOCUS
      canClose = class::CANCLOSE
      onClose = class::ONCLOSE
      open = class::OPEN
      scaleFontBold = false
      metric = 6	// Pixels
      height = 200
      left = 5
      top = 3
      width = 280
      text = ""
      clientEdge = true
      menuFile = "Basic.mnu"
   endwith


   this.qSample = new QUERY()
   this.qSample.parent = this
   with (this.qSample)
      left = 1
      top = 3
      sql = 'select * from "Sample.dbf"'
      active = true
   endwith


   with (this.qSample.rowset)
      onEdit = {;this.modified = true}

   endwith


   this.TEXT2 = new TEXT(this)
   with (this.TEXT2)
      height = 14
      left = 30
      top = 39
      width = 200
      variableHeight = true
      fontSize = 8
      text = "Fields Provided for Playing with ToolBars"
   endwith


   this.ENTRYFIELD1 = new ENTRYFIELD(this)
   with (this.ENTRYFIELD1)
      dataLink = form.qSample.rowset.fields["Field1"]
      height = 20
      left = 63
      top = 59
      width = 56
      fontSize = 8
   endwith


   this.ENTRYFIELD2 = new ENTRYFIELD(this)
   with (this.ENTRYFIELD2)
      dataLink = form.qSample.rowset.fields["Field2"]
      height = 20
      left = 130
      top = 59
      width = 56
      fontSize = 8
   endwith


   this.TEXT1 = new TEXT(this)
   with (this.TEXT1)
      height = 30
      left = 0
      top = 0
      width = 276
      anchor = 2	// Top
      colorNormal = "red/BtnFace"
      alignVertical = 1	// Middle
      alignHorizontal = 1	// Center
      fontSize = 12
      text = "Text1"
   endwith


   this.rowset = this.qsample.rowset

   function open
      // Incuded in base form for simplicity
      if type("this.appBase.CompanyName") # "U"
         this.text1.text = this.appBase.CompanyName
      endif
      if type("this.beforeOpen") == "FP"
         this.beforeOpen()
      endif
      // Included in base form for simplicity
      // Used for toolbars append button
      this.firstEditObj = this.entryfield1
      return super::Open()

   function canClose
      if type("this.rowset") # "U"
         if this.rowset.modified
            this.rowset.save()
         else
            this.rowset.abandon()
         endif
      endif
      return true

   function onClose
      if type("this.appBase") == "O"
         return this.appBase.ZapForm(this.RefName)
      endif
      return this.release()


   function release()
   	// Override the release method to clean up things like
      // deactivatiting queries and datamodules and
      // closing procedure files

      // Run custom event in the form onRelease
      if type("this.Form_onRelease()") == "FP"
      	this.Form_onRelease()
      endif
      return super::release()

   function onGotFocus
      if type("this.appBase") == "O"
         this.appBase.CurrentForm = this
         this.repaint()
      endif
      return

   function onLostFocus
      if type("this.appBase") == "O"
         this.appBase.CurrentForm = Null
      endif
      return

   function Repaint
      if type( "UpdateWindow" ) # "FP"
         extern CLOGICAL UpdateWindow( CHANDLE ) USER32
      endif
   RETURN UpdateWindow( this.hWnd )
endclass
